<template>
  <aside class="aside">
    <h4 class="aside__title">Добавление товара</h4>
    <b-form class="editor" @submit.prevent="handleSubmit">
      <b-form-group
        :state="errors.name"
        label="Наименование товара *"
        invalid-feedback="Поле является обязательным"
      >
        <b-form-input
          type="text"
          :state="errors.name"
          v-model.trim="form.name"
          placeholder="Введите наименование товара"
        ></b-form-input>
      </b-form-group>
      <b-form-group
        invalid-feedback="Поле является обязательным"
        label="Описание товара"
      >
        <b-form-textarea
          v-model="form.description"
          placeholder="Введите описание товара"
        ></b-form-textarea>
      </b-form-group>
      <b-form-group
        label="Ссылка на изображение товара *"
        invalid-feedback="Поле является обязательным"
      >
        <b-form-input
          type="text"
          :state="errors.image"
          v-model.trim="form.image"
          placeholder="Введите ссылку"
        ></b-form-input>
      </b-form-group>
      <b-form-group
        class="mb-5"
        label="Цена товара *"
        invalid-feedback="Поле является обязательным"
      >
        <b-form-input
          type="text"
          :state="errors.price"
          v-model.trim="form.price"
          :formatter="priceFormat"
          placeholder="Введите цену"
        ></b-form-input>
      </b-form-group>
      <b-button block pill type="submit" :disabled="!isFilled"
        >Добавить товар</b-button
      >
    </b-form>
  </aside>
</template>
<script>
export default {
  name: "Editor",
  data() {
    return {
      form: {
        name: "",
        image: "",
        price: "",
        description: "",
      },
      errors: {
        name: null,
        image: null,
        price: null,
        description: null,
      },
    };
  },
  computed: {
    isFilled() {
      const { form } = this;

      for (const field in form) {
        if (!!form[field]) {
          return true;
        }
      }

      return false;
    },
  },
  methods: {
    priceFormat(price) {
      price = price.replace(/\s/g, "");

      if (isNaN(Number(price))) {
        return this.form.price;
      }

      if (String(price).length > 3) {
        price = price.toString().replace(/\B(?=(\d{3})+(?!\d))/g, " ");
      }

      return price;
    },
    resetForm() {
      for (const key in this.form) {
        this.form[key] = "";
        this.errors[key] = null;
      }

      return;
    },
    invalidFeedback(el) {
      console.log();
    },
    validate() {
      let success = true;

      const { form, errors } = this;

      for (const field in form) {
        if (field == "description") continue;

        if (!form[field]) {
          success = false;

          errors[field] = false;
        } else {
          errors[field] = true;
        }
      }

      return success;
    },
    handleSubmit() {
      if (!this.validate()) return;

      const fields = Object.assign({}, this.form);

      fields.id = Math.floor(Date.now() / 1000);

      this.$store.commit("catalog/addCard", fields);

      return this.resetForm();
    },
  },
};
</script>
<style scoped>
.editor {
  padding: 24px;
  background: #fffefb;
  box-shadow: 0px 20px 30px rgba(0, 0, 0, 0.04),
    0px 6px 10px rgba(0, 0, 0, 0.02);
  border-radius: 4px;
}
</style>